#version 450 core

layout (location = 0) in vec3 position;
layout (location = 1) in vec2 uv;
layout (location = 2) in mat4 model;

out vec2 FragmentUV;

uniform mat4 view;
uniform mat4 projection;

mat4 update() {
	mat4 vm = view * model;
	vm[0][0] = model[0][0];
	vm[0][1] = 0;
	vm[0][2] = 0;
	vm[1][0] = 0;
	vm[1][1] = model[1][1];
	vm[1][2] = 0;
	vm[2][0] = 0;
	vm[2][1] = 0;
	vm[2][2] = model[2][2];
	
	return vm;
}

void main() {
	FragmentUV = uv;	
	gl_Position = projection * update() * vec4(position, 1);
}