#version 450 core

in FRAG_VALUES {
	vec2 FragmentUV;
	vec3 Position;
	vec3 Normal;
	vec3 View;
	//vec4 FragPosLightSpace;
}frag_in;

struct Light {
	vec3 position;
	vec3 color;
	float constant;
	float linear;
	float quadratic;
};


out vec4 Color;

uniform Light light;
uniform sampler2D diffuse;
uniform samplerCube shadow;
float far_plane =  25.0;

vec4 calcLight();
float calcShadow();
float calcShadowCube();

vec3 sampleDirVec[20] = vec3[] (
   vec3(1, 1, 1), vec3(1, -1, 1), vec3(-1, -1, 1), vec3(-1, 1, 1), 
   vec3(1, 1, -1), vec3(1, -1, -1), vec3(-1, -1, -1), vec3(-1, 1, -1),
   vec3(1, 1, 0), vec3(1, -1, 0), vec3(-1, -1, 0), vec3(-1, 1, 0),
   vec3(1, 0, 1), vec3(-1, 0, 1), vec3(1, 0, -1), vec3(-1, 0, -1),
   vec3(0, 1, 1), vec3(0, -1, 1), vec3(0, -1, -1), vec3(0, 1, -1)
);

vec3 test() {
return vec3(1);
}

void main() {
	//float distance = distance(light.position, frag_in.Position);
	//float attenuation = 1 /	(light.constant + light.linear * distance + light.quadratic * distance * distance);
	//Color = (calcLight() * texture(diffuse, frag_in.FragmentUV)) * attenuation;
	
	//Color = vec4(test(), 1);
	Color = calcLight() * texture(diffuse, frag_in.FragmentUV);
	
	
	//float val = calcShadow();
	
	//Color = vec4(calcShadow());
	
	//Color = vec4(frag_in.Normal * 0.5 + 0.5,1);
	
	//Color = texture(diffuse, frag_in.FragmentUV);
	//Color = vec4(light.position,1);
	//Color = vec4(abs(frag_in.Normal),1);
	//Color = texture(diffuse, frag_in.FragmentUV);
}

vec4 calcLight() {
	//diffuse
	
	vec3 N = normalize(frag_in.Normal);
	vec3 L = normalize(light.position - frag_in.Position);
	vec3 V = normalize(frag_in.View);

	float LdotN = dot(L, N);
	vec3 diffuse = max(LdotN, 0) * light.color * 0.8f;
	
	vec3 R = normalize((2 * dot(N, L) * N) - L);
	vec3 specular = pow(max(dot(V, R), 0), 50.0f) * light.color * 0.5f;
	
	return vec4(vec3(1,1,1) * 0.5 + (diffuse + specular) * calcShadowCube(),1);
}

float calcShadow() {
	/*vec3 coords = frag_in.FragPosLightSpace.xyz / frag_in.FragPosLightSpace.w;
	
	coords = coords * 0.5 + 0.5;
	float close = texture(shadow, coords.xy).r;
	float current = coords.z;
	float bias = max(0.05 *(1.0 - dot(light.position, frag_in.Normal)), 0.005);
	//float bias = 0.05;

	return current - bias > close? 0.0f : 1.0f;*/
	return 0;
	
}

float calcShadowCube() {
	float resultShadow = 0.0;
	vec3 toLight = frag_in.Position - light.position;
	//float close = texture(shadow, toLight).r * far_plane;
	float current = length(toLight);
    	float bias = 0.05;
    	int samples = 25;
    	float viewDist = length(frag_in.View - frag_in.Position);
    	float diskRad = (1.0 + (viewDist / far_plane)) / 200.0;
    	for(int i = 0; i < samples; ++i) {
        	float close = texture(shadow, toLight + sampleDirVec[i] * diskRad).r;
        	close *= far_plane;   
        	if(current - bias > close)
            		resultShadow += 1.0;
    	}
    	resultShadow  /= float(samples);    

    	return 1.0 - resultShadow;

	//return current - bias > close? 0.0f : 1.0f;
	
}