#version 450 core

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 uv;
layout (location = 3) in mat4 model;

out FRAG_VALUES {
	vec2 FragmentUV;
	vec3 Position;
	vec3 Normal;
	vec3 View;
	vec4 vertexColor;
	vec4 clipSpace;
	vec3 toCamVec;
	vec3 fromLightVector;
}vert_out;

uniform mat4 view;
uniform mat4 projection;
uniform vec3 cameraPos;
uniform vec3 lightPosition;

const float tiling = 3.0;

void main() {
	/*vert_out.FragmentUV = uv;
	vert_out.Normal = normalize(vec3(transpose(inverse(view * model)) * vec4(normal,0)));
	vert_out.Position = vec3(view * model * vec4(position, 1));
	vert_out.View = normalize(-vert_out.Position);*/	

	vec4 worldPos = model * vec4(position, 1.0);
	vert_out.clipSpace = projection * view * worldPos ;
	gl_Position = vert_out.clipSpace;
	vert_out.toCamVec = cameraPos - worldPos.xyz;
	vert_out.FragmentUV = uv * tiling;
	vert_out.fromLightVector = worldPos.xyz - lightPosition;

}